#include "defines.h"
#include "serial.h"

#define PMR1 ((volatile unsigned char *)0xffe0)
#define TXD (1<<1)

#define MSTCR1 ((volatile unsigned char *)0xfff9)
#define MSTS3 (1<<5)

#define SMR ((volatile unsigned char *)0xffa8)
#define BRR ((volatile unsigned char *)0xffa9)
#define SCR ((volatile unsigned char *)0xffaa)
#define TDR ((volatile unsigned char *)0xffab)
#define SSR ((volatile unsigned char *)0xffac)
#define RDR ((volatile unsigned char *)0xffad)

#define SMR_CKS_PER1  (0<<0)
#define SMR_CKS_PER4  (1<<0)
#define SMR_CKS_PER16 (2<<0)
#define SMR_CKS_PER64 (3<<0)
#define SMR_MP     (1<<2)
#define SMR_STOP   (1<<3)
#define SMR_PM     (1<<4)
#define SMR_PE     (1<<5)
#define SMR_CHR    (1<<6)
#define SMR_COM    (1<<7)

#define SCR_CKE0   (1<<0)
#define SCR_CKE1   (1<<1)
#define SCR_TEIE   (1<<2)
#define SCR_MPIE   (1<<3)
#define SCR_RE     (1<<4) /* ͭ */
#define SCR_TE     (1<<5) /* ͭ */
#define SCR_RIE    (1<<6) /* ͭ */
#define SCR_TIE    (1<<7) /* ͭ */

#define SSR_MPBT   (1<<0)
#define SSR_MPBR   (1<<1)
#define SSR_TEND   (1<<2)
#define SSR_PER    (1<<3)
#define SSR_FER    (1<<4)
#define SSR_OER    (1<<5)
#define SSR_RDRF   (1<<6) /* λ */
#define SSR_TDRE   (1<<7) /* λ */

/* ǥХ */
int serial_init(int index)
{
  *MSTCR1 &= ~MSTS3; /* SCI3 power-up */
  *PMR1 |= TXD; /* P22TXDȤƻѤ */

  *SCR = 0;
  *SMR = 0;
  *BRR = 51; /* 16MHzΥå9600bps(20MHzξ64ˤ) */
  *SCR = SCR_RE | SCR_TE; /* ǽ */
  *SSR = 0;

  return 0;
}

/* ǽ */
int serial_is_send_enable(int index)
{
  return *SSR & SSR_TDRE;
}

/* ʸ */
int serial_send_byte(int index, unsigned char c)
{
  /* ǽˤʤޤԤ */
  while (!serial_is_send_enable(index));
  *TDR = c;

  return 0;
}

/* ǽ */
int serial_is_recv_enable(int index)
{
  return *SSR & SSR_RDRF;
}

/* ʸ */
unsigned char serial_recv_byte(int index)
{
  /* ʸޤԤ */
  while (!serial_is_recv_enable(index));

  return *RDR;
}

/* ͭ */
int serial_intr_is_send_enable(int index)
{
  return *SCR & SCR_TIE;
}

/* ͭ */
void serial_intr_send_enable(int index)
{
  *SCR |= SCR_TIE;
}

/* ̵ */
void serial_intr_send_disable(int index)
{
  *SCR &= ~SCR_TIE;
}

/* ͭ */
int serial_intr_is_recv_enable(int index)
{
  return *SCR & SCR_RIE;
}

/* ͭ */
void serial_intr_recv_enable(int index)
{
  *SCR |= SCR_RIE;
}

/* ̵ */
void serial_intr_recv_disable(int index)
{
  *SCR &= ~SCR_RIE;
}
